<template>
  <div id="decision">
    <div class="login-box shadow-sm mb-5 bg-white rounded">
      <div class="p-5">
        <div class="row">
          <div class="col-6">
            <router-link class="btn btn-outline-warning" to="/CreateDecision">AGREGAR</router-link>
          </div>
          <div class="col-6 text-right">
            <label class="switch">
          <input type="checkbox" @click="showAllDecisions=!showAllDecisions">
          <span class="slider round"></span>
        </label>
        <p>Ver decisiones cerradas</p>
          </div>
        </div>
        
        <h5>Decisiones:</h5>
        
        <div v-for="(decision,index) in decision_options[filterOptions(decision_options)]" :key="index">

          <div v-if="index!=0">
            <div class="container" v-show="(decision.available || showAllDecisions)" >
              <h4>{{decision.question}}</h4>
              <div class="progress-item" v-for="(decision2,index2) in decision.answers" v-bind:prop="decision2[0]" v-bind:key="index2">
                <div class="options-text badge badge-dark text-wrap">
                  {{decision2[0]}}
                </div>
                <div class="progress"> 
                  <div
                  class="progress-bar-striped bg-info"
                  role="progressbar"
                  :style="{width: calculatePercent(decision2[1])+'%'}"
                  :aria-valuenow="calculatePercent(decision2[1])"
                  aria-valuemin="0"
                  aria-valuemax="100"
                  >{{Math.round(calculatePercent(decision2[1]))+'%'}}</div>

                </div>
              </div>
              <h5 v-show="decision.available==false" >Decisión cerrada</h5>             
              <div class="mt-4 mb-5">                
                <button class="btn btn-outline-danger float-right" v-show="decision.available==true" data-toggle="tooltip" data-placement="top"  title="solo se cierra si ya todos los miembros han votado" type="button"  @click="calculateTotalVotes(decision.answers,index)" >CERRAR</button>
                <button v-show="decision.available==true" type="button" class="btn btn-outline-success float-right mr-3" @click="vote(index)" >VOTAR</button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import { mapState, mapGetters } from 'vuex'
  import { RTDB } from "../main.js";

  export default {
    name: "ViewDecision",
    computed:{
      ...mapGetters(['getCodeFamily','getNoMembers']),
    },
    data() {
      return {
        showAllDecisions: false,
        decision_question: "",
        decision_options: [],
        number_votes:0,
      };
    },
    methods: {
      calculatePercent (votes) {
        if(this.getNoMembers===0){
          return 0;
        }
        else{
          let num = (100 * votes) / this.getNoMembers;
          return num;
        }
      },
      calculateTotalVotes (decision_options, index) {
        decision_options.forEach((option) => {
          this.number_votes += option[1]
        });

        if(this.number_votes >= this.getNoMembers){
          console.log(this.number_votes+this.getNoMembers);
          this.changeAvailability(index);

        }
      }, 
      filterOptions(decision_options){
        let lastIndex=0;
        lastIndex = decision_options.length;
        lastIndex--;
        return lastIndex;
      },
      vote(dcode){
        console.log("Aqui entro");
        this.$router.push({name:'VoteDecision', params: {DecisionCode: dcode}})
      },
      changeAvailability(index){
        RTDB.ref('family/'+this.getCodeFamily+'/decision/'+index).update({'available':false});
    },/*
    checkAvailability(){
      if(this.decision_options[filterOptions(decision_options)]!=undefined){
        this.calculateTotalVotes(decision_options[filterOptions(decision_options)].answers);
      }  
    }, */
  },
  mounted () {//1/answers  1/question
    RTDB.ref('family/'+this.getCodeFamily+'/decision/').on('value',snapshot=>this.decision_options.push(snapshot.val()));
    //RTDB.ref('family/'+this.code+'/decision/').on('value',snapshot=>this.decision_question=(snapshot.val()));
    //console.log(this.decision_options[0][Object.keys(this.decision_options[0])].question);
    
    
  },
};

</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.login-box{
  max-width: 100%;
}
.form-input, .form-input:focus{
  border-color: #3C394A;
  border-bottom-width: 2px;
  border-top: 0;
  border-right: 0;
  border-left: 0;
  border-radius: 0;
  box-shadow: none;
  max-width: 100%;
}
.form-input:focus{
  border-color: #009A9A;
}
.btn-primary {
  color: #fff;
  background-color: #009A9A;
  border-color: #009A9A;
}
.btn-primary:hover{
  background-color: #45b5b5 !important;
}

h5, h3 {
  color: #45b5b5;
  font-weight: bold;
}
.progress-item{
  margin-top: 1rem;
  position: relative;
  width: 100%;
}

.progress{
  min-height: 2rem;
  height: auto;
  max-height: 5rem;
}

.progress-bar-striped{
  text-align: left;
}

.options-text{
  float: left;
  width: auto;
  min-width: 10rem;
  max-width: 10rem;
  min-height: 2rem;

}

/* The switch - the box around the slider */
.switch {
  position: relative;
  display: inline-block;
  width: 60px;
  height: 34px;
}

/* Hide default HTML checkbox */
.switch input {
  opacity: 0;
  width: 0;
  height: 0;
}

/* The slider */
.slider {
  position: absolute;
  cursor: pointer;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: #ccc;
  -webkit-transition: .4s;
  transition: .4s;
}

.slider:before {
  position: absolute;
  content: "";
  height: 26px;
  width: 26px;
  left: 4px;
  bottom: 4px;
  background-color: white;
  -webkit-transition: .4s;
  transition: .4s;
}

input:checked + .slider {
  background-color: #2196F3;
}

input:focus + .slider {
  box-shadow: 0 0 1px #2196F3;
}

input:checked + .slider:before {
  -webkit-transform: translateX(26px);
  -ms-transform: translateX(26px);
  transform: translateX(26px);
}

/* Rounded sliders */
.slider.round {
  border-radius: 34px;
}

.slider.round:before {
  border-radius: 50%;
}
.btn-outline-warning {
  color: #009A9A;
  border-color: #009A9A;
}
.btn-outline-warning:hover {
  background-color: #009A9A;
  color: #fafafa;
  border-color: #fafafa;
}


</style>
